'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _graphql = require('graphql');

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var TitaniumEnumType = function () {
  function TitaniumEnumType(options) {
    _classCallCheck(this, TitaniumEnumType);

    var name = options.name;
    var _options$description = options.description;
    var description = _options$description === undefined ? '' : _options$description;
    var values = options.values;


    (0, _invariant2.default)(typeof name === 'string', 'TitaniumEnumType(constructor) expects \'name\' to be of type ' + ('\'String\', received \'' + (typeof name === 'undefined' ? 'undefined' : _typeof(name)) + '\' instead'));

    (0, _invariant2.default)(!name.endsWith('Connection') && !name.endsWith('Edge'), 'Titanium reserves the use of type names ending with Connection ' + ('and Edge for relay helpers. Please choose another name for \'' + name + '\'.'));

    this.name = name;
    this.description = description;

    this.setValues(values);
  }

  _createClass(TitaniumEnumType, [{
    key: 'setValues',
    value: function setValues(values) {
      if (!(values instanceof Object)) {
        throw new TypeError('Value of argument "values" violates contract.\n\nExpected:\nObject\n\nGot:\n' + _inspect(values));
      }

      (0, _invariant2.default)((typeof values === 'undefined' ? 'undefined' : _typeof(values)) === 'object' && !Array.isArray(values), 'setFields expects \'values\' to be of type \'object\', ' + ('received \'' + (typeof values === 'undefined' ? 'undefined' : _typeof(values)) + '\' instead'));

      // @TODO: Sanitize values first
      this._values = values;
    }
  }, {
    key: '_toGraphQL',
    value: function _toGraphQL() {
      var outputObject = new _graphql.GraphQLEnumType({
        name: this.name,
        description: this.description,
        values: this._values
      });

      outputObject.__rawTitanium = this;

      return outputObject;
    }
  }]);

  return TitaniumEnumType;
}();

exports.default = TitaniumEnumType;

function _inspect(input, depth) {
  var maxDepth = 4;
  var maxKeys = 15;

  if (depth === undefined) {
    depth = 0;
  }

  depth += 1;

  if (input === null) {
    return 'null';
  } else if (input === undefined) {
    return 'void';
  } else if (typeof input === 'string' || typeof input === 'number' || typeof input === 'boolean') {
    return typeof input === 'undefined' ? 'undefined' : _typeof(input);
  } else if (Array.isArray(input)) {
    if (input.length > 0) {
      var _ret = function () {
        if (depth > maxDepth) return {
            v: '[...]'
          };

        var first = _inspect(input[0], depth);

        if (input.every(function (item) {
          return _inspect(item, depth) === first;
        })) {
          return {
            v: first.trim() + '[]'
          };
        } else {
          return {
            v: '[' + input.slice(0, maxKeys).map(function (item) {
              return _inspect(item, depth);
            }).join(', ') + (input.length >= maxKeys ? ', ...' : '') + ']'
          };
        }
      }();

      if ((typeof _ret === 'undefined' ? 'undefined' : _typeof(_ret)) === "object") return _ret.v;
    } else {
      return 'Array';
    }
  } else {
    var keys = Object.keys(input);

    if (!keys.length) {
      if (input.constructor && input.constructor.name && input.constructor.name !== 'Object') {
        return input.constructor.name;
      } else {
        return 'Object';
      }
    }

    if (depth > maxDepth) return '{...}';
    var indent = '  '.repeat(depth - 1);
    var entries = keys.slice(0, maxKeys).map(function (key) {
      return (/^([A-Z_$][A-Z0-9_$]*)$/i.test(key) ? key : JSON.stringify(key)) + ': ' + _inspect(input[key], depth) + ';';
    }).join('\n  ' + indent);

    if (keys.length >= maxKeys) {
      entries += '\n  ' + indent + '...';
    }

    if (input.constructor && input.constructor.name && input.constructor.name !== 'Object') {
      return input.constructor.name + ' {\n  ' + indent + entries + '\n' + indent + '}';
    } else {
      return '{\n  ' + indent + entries + '\n' + indent + '}';
    }
  }
}